// http://zx-pk.ru/showthread.php?t=19960 //

#include <stdio.h>
#include <windows.h>   
#include "vsm.hpp"   

#define SIZE_X  480 //(640*2)
#define SIZE_Y  340 //(316*2)
//#define ASPECT  (1) //1  1280x632 2  640x316 


class DISPLAY : public IACTIVEMODEL,public IDSIMMODEL 
{ 
public: 
  int isdigital (CHAR *pinname); 
  void setup (IINSTANCE *inst, IDSIMCKT *dsim); 
  void runctrl (RUNMODES mode); 
  void actuate (REALTIME time, ACTIVESTATE newstate); 
  BOOL indicate (REALTIME time, ACTIVEDATA *data); 
  void simulate (ABSTIME time, DSIMMODES mode); 
  void callback (ABSTIME time, EVENTID eventid); 
  void initialize (ICOMPONENT *cpt); 
  ISPICEMODEL *getspicemodel (CHAR *device); 
  IDSIMMODEL *getdsimmodel (CHAR *device); 
  void plot (ACTIVESTATE state); 
  void animate (INT element, ACTIVEDATA *newstate); 
  BOOL actuate (WORD key, INT x, INT y, DWORD flags); 
 
private: 
  IINSTANCE *instance;  
  IDSIMCKT *ckt;      
  ICOMPONENT *component;   
  IDSIMPIN *en_video; 
  IDSIMPIN *en_sync_h; 
  IDSIMPIN *en_sync_v; 
  IDSIMPIN *en_pclk; 
}; 

HANDLE hProcessHeap;
HDC dc,buffer;
HBITMAP bmp;
PCHAR lin,slin;
int fsize,lsize;
char vst,hst,fcn;
LONGLONG ptime;
HWND hwnd;              
WNDCLASSEX wincl;      
BITMAPINFO bmi;
DWORD itg;


LRESULT CALLBACK WindowProcedure (HWND, UINT, WPARAM, LPARAM);

void CreateDisplayWindow();
char szClassName[ ] = "TVOUT Display";


/*__declspec(naked) void memcpy_mmx16(void* dst, void* src, DWORD len)
{
__asm
{
  push    esi
  push    edi
  push    ecx

  mov   edi, [esp+12+4]
  mov   esi, [esp+12+8]
  mov   ecx, [esp+12+12]
  
  shr   ecx,4

l1:
  movq    mm0,[esi]
  movq    mm1,[esi+8]
  movntq    [edi],mm0
  movntq    [edi+8],mm1
  add   esi,16
  add   edi,16
  dec   ecx
  jnz   l1
  
  emms
  pop     ecx
  pop   edi
  pop   esi
  retn
}
}
*/
/*
void snc(unsigned int l) {
  PCHAR pp1,pp2;
  DWORD i,d1;
  DWORD delta;
  DWORD itg;
  d1=SIZE_X*l;
  pp1=(PCHAR)lin+(unsigned int)d1;
  pp2=(PCHAR)slin+(unsigned int)d1;
  for(i=d1;i<d1+SIZE_X;i++) { //
    itg++;
    if (lin[i]!=0x45) itg=0;    
    if (itg==(77/ASPECT)) break;
  }

  itg=i-itg;
  delta=itg-d1;
  memcpy(pp2,pp1+delta,SIZE_X-delta);
  memcpy(pp2+(SIZE_X-delta),pp1,itg);
}


void  sync() {
  DWORD ik;
  for(ik=0;ik<SIZE_Y;ik++) snc(ik);

}
*/

extern "C" IDSIMMODEL __declspec(dllexport)*createdsimmodel(CHAR *device,ILICENCESERVER *ils)   {     
        ils->authorize(0x88888888, 0x69);  
        return new DISPLAY;   
}   
       

extern "C" VOID __declspec(dllexport)deletedsimmodel(IDSIMMODEL*model)   {   
    HeapFree(hProcessHeap,0,lin);
    HeapFree(hProcessHeap,0,slin);
    DestroyWindow(hwnd);
    UnregisterClass(szClassName,0);
    delete (DISPLAY*)model;  
}   
       
       
int DISPLAY::isdigital(CHAR *pinname)   {   
        return 1;   
}   
       
       
void DISPLAY::setup(IINSTANCE *inst,IDSIMCKT *dsim)   {   
    instance = inst;    
          ckt = dsim;     
        
    hProcessHeap=GetProcessHeap();
    lin=(PCHAR)HeapAlloc(hProcessHeap, 0, SIZE_X*10*SIZE_Y); 
    slin=(PCHAR)HeapAlloc(hProcessHeap, 0, SIZE_X*10*SIZE_Y); 
    
    CreateDisplayWindow();
          ptime=0;
    fsize=0;
    itg=0;
  vst=0;
  hst=0;
  fcn=0;
    en_video = instance->getdsimpin("VIDEO,video", true);   
        en_video->setstate(FLT);   
    en_sync_h = instance->getdsimpin("SYNC_H", true);   
        en_sync_h->setstate(FLT);   
    en_sync_v = instance->getdsimpin("SYNC_V", true);   
        en_sync_v->setstate(FLT);   
    en_pclk = instance->getdsimpin("PCLK", true);   
        en_pclk->setstate(FLT);   
        
}   
       
void DISPLAY::runctrl(RUNMODES mode)  {   
       
}   
       
       
void DISPLAY::actuate(REALTIME time,ACTIVESTATE newstate) {   
           
}   
       
BOOL DISPLAY::indicate(REALTIME time,ACTIVEDATA *data)   {      
        return TRUE;   
}   
       
       
void DISPLAY::simulate (ABSTIME time,DSIMMODES mode) {      
    LONGLONG dtime;
    char c;
    int i;
    double dms,bits;
    BOOL st_v=ishigh(en_video->istate());
    BOOL st_sh=ishigh(en_sync_h->istate());
    BOOL st_sv=ishigh(en_sync_v->istate());
    BOOL st_pc=ishigh(en_pclk->istate());
/*    
    if (ptime==0) ptime=time;
    dtime=time-ptime;
    ptime=time;
    dms=dtime/(50000.0*ASPECT);
    bits=dms;
    
    if (st) c=0x45; else c=0xda; 
    if (fsize<(SIZE_X*SIZE_Y)+1) {
      if ((fsize+bits)>SIZE_X*SIZE_Y*3) bits=0; //HACK!:   ,  
      i=fsize;
      memset(lin+i,c,fsize+bits);
      fsize+=bits;
    } else {
      sync();       
      SetBitmapBits(bmp,SIZE_X*SIZE_Y,slin);
      SelectObject(buffer,bmp);
      BitBlt(dc,0,0,SIZE_X,SIZE_Y,buffer,0,0,SRCCOPY);
      fsize=0;
    }
*/
      if (!st_sh)
    {
      if (hst==0)
      {
      if (fcn<4) fcn++;
      if (fcn<3)
       {
       c=0xda;
       memset(lin,c,SIZE_X*SIZE_Y);
       SetBitmapBits(bmp,SIZE_X*SIZE_Y,lin);
       SelectObject(buffer,bmp);
       BitBlt(dc,0,0,SIZE_X,SIZE_Y,buffer,0,0,SRCCOPY);
       }
      fsize=0;
      hst=1;
      }
    }
    else
    {
      hst=0;
    if (!st_sv)
      {
      if (vst==0)
       {
       lsize=0;
       c=0x45;
       memset(lin+fsize+SIZE_X,c,SIZE_X);
         SetBitmapBits(bmp,SIZE_X*SIZE_Y,lin);
       SelectObject(buffer,bmp);
       BitBlt(dc,0,0,SIZE_X,SIZE_Y,buffer,0,0,SRCCOPY);
       vst=1;
       fsize+=SIZE_X;
       }
      }
     else
      {
      vst=0;
      if (!st_pc)
        {
        if (st_v) c=0x45; else c=0xda;
        memset(lin+fsize+lsize,c,1);
        lsize++;
        }
      }
/*
    fsize+=SIZE_X;
    if (fsize>SIZE_X*SIZE_Y) {fsize=0;qq++;}
for (i=0;i<fsize;i++)
{
    if ((i+qq)%2) c=0x45; else c=0xda; 
      memset(lin+i,c,1);
}
      SetBitmapBits(bmp,SIZE_X*SIZE_Y,lin);
      SelectObject(buffer,bmp);
      BitBlt(dc,0,0,SIZE_X,SIZE_Y,buffer,0,0,SRCCOPY);
*/
    }
}   
       
      
void DISPLAY::callback(ABSTIME time,EVENTID eventid)   {   
       
}   
              
extern "C" IACTIVEMODEL __declspec(dllexport)*createactivemodel(CHAR *device,ILICENCESERVER *ils)  {    
        ils->authorize (0);     
        return new DISPLAY;   
}   
              
extern "C" VOID  __declspec(dllexport)deleteactivemodel (IACTIVEMODEL *model)  {    
    
    
  delete (DISPLAY*)model;   
}   
               
void DISPLAY::initialize(ICOMPONENT *cpt)  {    

}   
               
ISPICEMODEL *DISPLAY::getspicemodel(CHAR *)  {    
        return NULL;    
}   
       
IDSIMMODEL  *DISPLAY::getdsimmodel(CHAR *)  {      
        return this;    
}   

void DISPLAY::plot(ACTIVESTATE state)  {   
}   
        
void DISPLAY::animate(INT element, ACTIVEDATA *data)  {    
          
}   

BOOL DISPLAY::actuate(WORD key, INT x, INT y, DWORD flags)  {    
        return FALSE;    
}  



void CreateDisplayWindow()
{
  
    wincl.hInstance = 0;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WindowProcedure;     
    wincl.style = CS_DBLCLKS;                
    wincl.cbSize = sizeof (WNDCLASSEX);
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;      
    wincl.cbClsExtra = 0;           
    wincl.cbWndExtra = 0;    
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    if (!RegisterClassEx(&wincl)) return;

    hwnd = CreateWindowEx (
           0,                   
           szClassName,         
           "TVOUT Display",     
           WS_EX_TOPMOST, 
           CW_USEDEFAULT,       
           CW_USEDEFAULT,       
           SIZE_X,              
           SIZE_Y,              
           HWND_DESKTOP,        
           NULL,                
           0,       
           NULL           
           );

    ShowWindow(hwnd,SW_SHOW);
  
  dc=GetDC(hwnd);
    buffer=CreateCompatibleDC(dc);

    bmi.bmiHeader.biSize=sizeof(BITMAPINFOHEADER);
    
    bmi.bmiHeader.biWidth=SIZE_X;
    bmi.bmiHeader.biHeight=-SIZE_Y;
    bmi.bmiHeader.biPlanes=1;
    bmi.bmiHeader.biBitCount=8;
    bmi.bmiHeader.biCompression=BI_RGB;
    bmi.bmiHeader.biSizeImage=0;
    bmi.bmiHeader.biXPelsPerMeter=0; 
    bmi.bmiHeader.biYPelsPerMeter=0;
    bmi.bmiHeader.biClrUsed=0;
    bmi.bmiHeader.biClrImportant=0; 



    bmi.bmiColors[0xda].rgbBlue=0;
    bmi.bmiColors[0xda].rgbGreen=0;
    bmi.bmiColors[0xda].rgbRed=0;
    bmi.bmiColors[0xda].rgbReserved=0;

    bmi.bmiColors[0x45].rgbBlue=155;
    bmi.bmiColors[0x45].rgbGreen=155;
    bmi.bmiColors[0x45].rgbRed=155;
    bmi.bmiColors[0x45].rgbReserved=0;

    bmp=CreateDIBSection(buffer,&bmi,DIB_RGB_COLORS,(void**)slin,NULL,0);
}


LRESULT CALLBACK WindowProcedure (HWND hwnd,UINT message,WPARAM wParam,LPARAM lParam)
{
  switch(message)                 
    {
    case WM_DESTROY:
            PostQuitMessage(0);     
            break;
        default:                     
            return DefWindowProc(hwnd, message, wParam, lParam);
    }

    return 0;
}
